pcl::VoxelGridLabel Class Reference

`#include <pcl/filters/voxel_grid_label.h>`

Inheritance diagram for pcl::VoxelGridLabel:

## Public Types

using | Ptr = shared_ptr< VoxelGridLabel >
using | ConstPtr = shared_ptr< const VoxelGridLabel >
Public Types inherited from pcl::VoxelGrid< pcl::PointXYZRGBL >
using | Ptr = shared_ptr< VoxelGrid< pcl::PointXYZRGBL > >
using | ConstPtr = shared_ptr< const VoxelGrid< pcl::PointXYZRGBL > >
Public Types inherited from pcl::Filter< pcl::PointXYZRGBL >
using | Ptr = shared_ptr< Filter< pcl::PointXYZRGBL > >
using | ConstPtr = shared_ptr< const Filter< pcl::PointXYZRGBL > >
using | PointCloud = pcl::PointCloud< pcl::PointXYZRGBL >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
Public Types inherited from pcl::PCLBase< pcl::PointXYZRGBL >
using | PointCloud = pcl::PointCloud< pcl::PointXYZRGBL >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| VoxelGridLabel ()
| Constructor. More...
Public Member Functions inherited from pcl::VoxelGrid< pcl::PointXYZRGBL >
| VoxelGrid ()
| Empty constructor. More...
| ~VoxelGrid ()
| Destructor. More...
void | setLeafSize (const Eigen::Vector4f &leaf_size)
| Set the voxel grid leaf size. More...
void | setLeafSize (float lx, float ly, float lz)
| Set the voxel grid leaf size. More...
Eigen::Vector3f | getLeafSize () const
| Get the voxel grid leaf size. More...
void | setDownsampleAllData (bool downsample)
| Set to true if all fields need to be downsampled, or false if just XYZ. More...
bool | getDownsampleAllData () const
| Get the state of the internal downsampling parameter (true if all fields need to be downsampled, false if just XYZ). More...
void | setMinimumPointsNumberPerVoxel (unsigned int min_points_per_voxel)
| Set the minimum number of points required for a voxel to be used. More...
unsigned int | getMinimumPointsNumberPerVoxel () const
| Return the minimum number of points required for a voxel to be used. More...
void | setSaveLeafLayout (bool save_leaf_layout)
| Set to true if leaf layout information needs to be saved for later access. More...
bool | getSaveLeafLayout () const
| Returns true if leaf layout information will to be saved for later access. More...
Eigen::Vector3i | getMinBoxCoordinates () const
| Get the minimum coordinates of the bounding box (after filtering is performed). More...
Eigen::Vector3i | getMaxBoxCoordinates () const
| Get the minimum coordinates of the bounding box (after filtering is performed). More...
Eigen::Vector3i | getNrDivisions () const
| Get the number of divisions along all 3 axes (after filtering is performed). More...
Eigen::Vector3i | getDivisionMultiplier () const
| Get the multipliers to be applied to the grid coordinates in order to find the centroid index (after filtering is performed). More...
int | getCentroidIndex (const pcl::PointXYZRGBL &p) const
| Returns the index in the resulting downsampled cloud of the specified point. More...
std::vector< int > | getNeighborCentroidIndices (const pcl::PointXYZRGBL &reference_point, const Eigen::MatrixXi &relative_coordinates) const
| Returns the indices in the resulting downsampled cloud of the points at the specified grid coordinates, relative to the grid coordinates of the specified point (or -1 if the cell was empty/out of bounds). More...
std::vector< int > | getLeafLayout () const
| Returns the layout of the leafs for fast access to cells relative to current position. More...
Eigen::Vector3i | getGridCoordinates (float x, float y, float z) const
| Returns the corresponding (i,j,k) coordinates in the grid of point (x,y,z). More...
int | getCentroidIndexAt (const Eigen::Vector3i &ijk) const
| Returns the index in the downsampled cloud corresponding to a given set of coordinates. More...
void | setFilterFieldName (const std::string &field_name)
| Provide the name of the field to be used for filtering data. More...
const std::string | getFilterFieldName () const
| Get the name of the field used for filtering. More...
void | setFilterLimits (const double &limit_min, const double &limit_max)
| Set the field filter limits. More...
void | getFilterLimits (double &limit_min, double &limit_max) const
| Get the field filter limits (min/max) set by the user. More...
void | setFilterLimitsNegative (const bool limit_negative)
| Set to true if we want to return the data outside the interval specified by setFilterLimits (min, max). More...
void | getFilterLimitsNegative (bool &limit_negative) const
| Get whether the data outside the interval (min/max) is to be returned (true) or inside (false). More...
bool | getFilterLimitsNegative () const
| Get whether the data outside the interval (min/max) is to be returned (true) or inside (false). More...
Public Member Functions inherited from pcl::Filter< pcl::PointXYZRGBL >
| Filter (bool extract_removed_indices=false)
| Empty constructor. More...
| ~Filter ()
| Empty destructor. More...
const IndicesConstPtr | getRemovedIndices () const
| Get the point indices being removed. More...
void | getRemovedIndices (PointIndices &pi)
| Get the point indices being removed. More...
void | filter (PointCloud &output)
| Calls the filtering method and returns the filtered dataset in output. More...
Public Member Functions inherited from pcl::PCLBase< pcl::PointXYZRGBL >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
const PointCloudConstPtr | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
const IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used. More...
const IndicesConstPtr | getIndices () const
| Get a pointer to the vector of indices used. More...
const pcl::PointXYZRGBL & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

void | applyFilter (PointCloud &output) override
| Filter cloud and initializes voxel structure. More...
Protected Member Functions inherited from pcl::VoxelGrid< pcl::PointXYZRGBL >
void | applyFilter (PointCloud &output) override
| Downsample a Point Cloud using a voxelized grid approach. More...
Protected Member Functions inherited from pcl::Filter< pcl::PointXYZRGBL >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
Protected Member Functions inherited from pcl::PCLBase< pcl::PointXYZRGBL >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Additional Inherited Members

Protected Types inherited from pcl::VoxelGrid< pcl::PointXYZRGBL >
using | PointCloud = typename Filter< pcl::PointXYZRGBL >::PointCloud
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | FieldList = typename pcl::traits::fieldList< pcl::PointXYZRGBL >::type
Protected Attributes inherited from pcl::VoxelGrid< pcl::PointXYZRGBL >
Eigen::Vector4f | leaf_size_
| The size of a leaf. More...
Eigen::Array4f | inverse_leaf_size_
| Internal leaf sizes stored as 1/leaf_size_ for efficiency reasons. More...
bool | downsample_all_data_
| Set to true if all fields need to be downsampled, or false if just XYZ. More...
bool | save_leaf_layout_
| Set to true if leaf layout information needs to be saved in leaf_layout_. More...
std::vector< int > | leaf_layout_
| The leaf layout information for fast access to cells relative to current position. More...
Eigen::Vector4i | min_b_
| The minimum and maximum bin coordinates, the number of divisions, and the division multiplier. More...
Eigen::Vector4i | max_b_
Eigen::Vector4i | div_b_
Eigen::Vector4i | divb_mul_
std::string | filter_field_name_
| The desired user filter field name. More...
double | filter_limit_min_
| The minimum allowed filter value a point will be considered from. More...
double | filter_limit_max_
| The maximum allowed filter value a point will be considered from. More...
bool | filter_limit_negative_
| Set to true if we want to return the data outside (filter_limit_min_;filter_limit_max_). More...
unsigned int | min_points_per_voxel_
| Minimum number of points per voxel for the centroid to be computed. More...
Protected Attributes inherited from pcl::Filter< pcl::PointXYZRGBL >
IndicesPtr | removed_indices_
| Indices of the points that are removed. More...
std::string | filter_name_
| The filter name. More...
bool | extract_removed_indices_
| Set to true if we want to return the indices of the removed points. More...
Protected Attributes inherited from pcl::PCLBase< pcl::PointXYZRGBL >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

Author
  Christian Potthast (potth.nosp@m.ast@.nosp@m.usc.e.nosp@m.du)

Definition at line 50 of file voxel_grid_label.h.

## Member Typedef Documentation

## ConstPtr

using pcl::VoxelGridLabel::ConstPtr = shared_ptr<const VoxelGridLabel>

Definition at line 55 of file voxel_grid_label.h.

## Ptr

using pcl::VoxelGridLabel::Ptr = shared_ptr<VoxelGridLabel>

Definition at line 54 of file voxel_grid_label.h.

## Constructor & Destructor Documentation

## VoxelGridLabel()

pcl::VoxelGridLabel::VoxelGridLabel | ( |  | ) |

inline

Constructor.

Sets leaf_size_ to 0.

Definition at line 61 of file voxel_grid_label.h.

## Member Function Documentation

## applyFilter()

void pcl::VoxelGridLabel::applyFilter | ( | PointCloud & | output | ) |

override protected virtual

Filter cloud and initializes voxel structure.

Parameters

  [out] | output | cloud containing centroids of voxels containing a sufficient number of points

Implements pcl::Filter< pcl::PointXYZRGBL >.

The documentation for this class was generated from the following file:

- pcl/filters/voxel_grid_label.h